// VCDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VCDemo.h"
#include "VCDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg dialog

CVCDemoDlg::CVCDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVCDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVCDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	
	init = 0;
}

void CVCDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVCDemoDlg)
	DDX_Control(pDX, IDC_PAGEUP, PAGEUP);
	DDX_Control(pDX, IDC_PAGEDOWN, PAGEDOWN);
	DDX_Control(pDX, IDC_LINEUP, LINEUP);
	DDX_Control(pDX, IDC_LINEDOWN, LINEDOWN);
	DDX_Control(pDX, IDC_BIG, BIG);
	DDX_Control(pDX, IDC_EARTH, EARTH);
	DDX_Control(pDX, IDC_EQ1, EQ1);
	DDX_Control(pDX, IDC_EQ10, EQ10);
	DDX_Control(pDX, IDC_EQ11, EQ11);
	DDX_Control(pDX, IDC_EQ12, EQ12);
	DDX_Control(pDX, IDC_EQ2, EQ2);
	DDX_Control(pDX, IDC_EQ3, EQ3);
	DDX_Control(pDX, IDC_EQ4, EQ4);
	DDX_Control(pDX, IDC_EQ5, EQ5);
	DDX_Control(pDX, IDC_EQ6, EQ6);
	DDX_Control(pDX, IDC_EQ7, EQ7);
	DDX_Control(pDX, IDC_EQ8, EQ8);
	DDX_Control(pDX, IDC_EQ9, EQ9);
	DDX_Control(pDX, IDC_FACE1, FACE1);
	DDX_Control(pDX, IDC_FACE2, FACE2);
	DDX_Control(pDX, IDC_REVERSE, REVERSE);
	DDX_Control(pDX, IDC_TANK, TANK);
	DDX_Control(pDX, IDC_THERM, THERM);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVCDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CVCDemoDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LINEDOWN, OnLinedown)
	ON_BN_CLICKED(IDC_LINEUP, OnLineup)
	ON_BN_CLICKED(IDC_PAGEDOWN, OnPagedown)
	ON_BN_CLICKED(IDC_PAGEUP, OnPageup)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVCDemoDlg message handlers

BOOL CVCDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVCDemoDlg::OnPaint() 
{
	if (IsIconic()) {
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
		}
	else {
		CDialog::OnPaint();
		}

	if (!init) {
		init = 1;

		SetTimer(1000,55,NULL);
		}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CVCDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

BEGIN_EVENTSINK_MAP(CVCDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CVCDemoDlg)
	ON_EVENT(CVCDemoDlg, IDC_BIG, -601 /* DblClick */, OnDblClickBig, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EARTH, -601 /* DblClick */, OnDblClickEarth, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ1, -601 /* DblClick */, OnDblClickEq1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ10, -601 /* DblClick */, OnDblClickEq10, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ11, -601 /* DblClick */, OnDblClickEq11, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ12, -601 /* DblClick */, OnDblClickEq12, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ2, -601 /* DblClick */, OnDblClickEq2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ3, -601 /* DblClick */, OnDblClickEq3, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ4, -601 /* DblClick */, OnDblClickEq4, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ5, -601 /* DblClick */, OnDblClickEq5, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ6, -601 /* DblClick */, OnDblClickEq6, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ7, -601 /* DblClick */, OnDblClickEq7, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ8, -601 /* DblClick */, OnDblClickEq8, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_EQ9, -601 /* DblClick */, OnDblClickEq9, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_FACE1, -601 /* DblClick */, OnDblClickFace1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_FACE2, -601 /* DblClick */, OnDblClickFace2, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_REVERSE, -601 /* DblClick */, OnDblClickReverse, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_TANK, -601 /* DblClick */, OnDblClickTank, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_THERM, -601 /* DblClick */, OnDblClickTherm, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_FACE1, 1 /* Slide */, OnSlideFace1, VTS_NONE)
	ON_EVENT(CVCDemoDlg, IDC_FACE2, 1 /* Slide */, OnSlideFace2, VTS_NONE)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()

void CVCDemoDlg::OnDblClickBig() 
{
	BIG.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEarth() 
{
	EARTH.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq1() 
{
	EQ1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq10() 
{
	EQ10.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq11() 
{
	EQ11.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq12() 
{
	EQ12.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq2() 
{
	EQ2.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq3() 
{
	EQ3.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq4() 
{
	EQ4.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq5() 
{
	EQ5.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq6() 
{
	EQ6.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq7() 
{
	EQ7.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq8() 
{
	EQ8.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickEq9() 
{
	EQ9.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickFace1() 
{
	FACE1.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickFace2() 
{
	FACE2.ShowPropertyPage();
}

void CVCDemoDlg::OnLinedown() 
{
	BIG.SetValue(BIG.GetValue()-1.0f);
}

void CVCDemoDlg::OnLineup() 
{
	BIG.SetValue(BIG.GetValue()+1.0f);
}

void CVCDemoDlg::OnPagedown() 
{
	BIG.SetValue(BIG.GetValue()-100.0f);
}

void CVCDemoDlg::OnPageup() 
{
	BIG.SetValue(BIG.GetValue()+100.0f);
}

void CVCDemoDlg::OnDblClickReverse() 
{
	REVERSE.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickTank() 
{
	TANK.ShowPropertyPage();
}

void CVCDemoDlg::OnDblClickTherm() 
{
	THERM.ShowPropertyPage();
}


void CVCDemoDlg::OnSlideFace1() 
{
	FACE2.SetValue(FACE1.GetValue());
}

void CVCDemoDlg::OnSlideFace2() 
{
	FACE1.SetValue(FACE2.GetValue());
}


void CVCDemoDlg::OnTimer(UINT nIDEvent) 
{
    TANK.SetValue(TANK.GetValue() + (float) rand()/(float) RAND_MAX - 0.5f);
    
    REVERSE.SetValue(REVERSE.GetValue() + 2.0f * (float) rand()/(float) RAND_MAX - 1.0f);
	
    EQ12.SetValue(EQ12.GetValue() + (float) rand()/(float) RAND_MAX * 30.0f - 15.0f);
	EQ1.SetValue(EQ2.GetValue());
	EQ2.SetValue(EQ3.GetValue());
	EQ3.SetValue(EQ4.GetValue());
	EQ4.SetValue(EQ5.GetValue());
	EQ5.SetValue(EQ6.GetValue());
	EQ6.SetValue(EQ7.GetValue());
	EQ7.SetValue(EQ8.GetValue());
	EQ8.SetValue(EQ9.GetValue());
	EQ9.SetValue(EQ10.GetValue());
	EQ10.SetValue(EQ11.GetValue());
	EQ11.SetValue(EQ12.GetValue());
	
	CDialog::OnTimer(nIDEvent);
}

BOOL CVCDemoDlg::DestroyWindow() 
{
	KillTimer(1000);
	
	return CDialog::DestroyWindow();
}
